// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'

//INTERNAL EVENT
var EVT_UPDATE_PROFILE = "EVT_UPDATE_PROFILE";
var EVT_UPDATE_CONSUMPTION = "EVT_UPDATE_CONSUMPTION";
var EVT_UPDATE_FOODLIST = "EVT_UPDATE_FOODLIST";
var EVT_UPDATE_WEIGHT = "EVT_UPDATE_WEIGHT";
var EVT_OPEN_CONSUMPTION = "EVT_OPEN_CONSUMPTION";
var EVT_OPEN_WEIGHING = "EVT_OPEN_WEIGHING";
var EVT_OPEN_EXERCICE = "EVT_OPEN_EXERCICE";

function uuid() {
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
    var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
    return v.toString(16);
  });
}

var admobid = {};
if( /(android)/i.test(navigator.userAgent) ) { // for android
    admobid = {
        banner: 'ca-app-pub-8811220453137079/4050735528', // or DFP format "/6253334/dfp_example_ad"
        interstitial: 'ca-app-pub-8811220453137079/4759167528'
    };
} else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
    admobid = {
        banner: 'ca-app-pub-8811220453137079/6471403125', // or DFP format "/6253334/dfp_example_ad"
        interstitial: 'ca-app-pub-8811220453137079/6235900729 '
    };
} else { // for windows phone
    admobid = {
        banner: 'ca-app-pub-xxx/zzz', // or DFP format "/6253334/dfp_example_ad"
        interstitial: 'ca-app-pub-xxx/kkk'
    };
}

function initAd(){
  if(!AdMob) return;
  var deviceOS  = device.platform;  //fetch the device operating system
  var deviceOSVersion = parseFloat(device.version);  //fetch the device OS version

  if (deviceOS == "Android" && deviceOSVersion<4.2) {
    AdMob.prepareInterstitial( {adId:admobid.interstitial, autoShow:true} );
  } else {
    AdMob.createBanner( {
      adId: admobid.banner,
      position: AdMob.AD_POSITION.BOTTOM_CENTER,
      overlap: false,
      offsetTopBar: false,
      autoShow: true } );
  }
}

if(( /(ipad|iphone|ipod|android|windows phone)/i.test(navigator.userAgent) )) {
   document.addEventListener('deviceready', initAd, false);
}

var app = angular.module('starter', ['ionic','pascalprecht.translate','js-data','chart.js','ngCordova'])

.directive('chartScatter', ['ChartJsFactory', function (ChartJsFactory) { return new ChartJsFactory('Scatter'); }])

.config(function($translateProvider, $provide, $cordovaAppRateProvider){
  $translateProvider.translations('en', i18n_EN);
  $translateProvider.translations('fr', i18n_FR);

  $translateProvider.preferredLanguage((navigator.language || navigator.userLanguage).split("-")[0]);
  $translateProvider.fallbackLanguage("en");
  //  $translateProvider.useSanitizeValueStrategy('sanitize');

  /*document.addEventListener("deviceready", function () {

    var prefs = {
      language: 'en',
      appName: 'WW Tools Free',
      iosURL: '<my_app_id>',
      androidURL: 'market://details?id=info.octera.wwtools.free',
      windowsURL: 'ms-windows-store:Review?name=<...>',
      usesUntilPrompt: 10
    };

    $cordovaAppRateProvider.setPreferences(prefs)

  }, false);*/

  $provide.decorator("$exceptionHandler", ['$delegate', function($delegate) {
    return function(exception, cause) {
      if (window.onerror) {
        onError(exception, cause);
      }
      $delegate(exception, cause);
    };
  }]);

  function onError(exception, cause) {
    var msg = exception.toString();
    var stack = exception.stack;
    if (window.cordova) {
      cordova.exec(function(){}, function(){}, 'CDVCrittercism', 'crittercismLogUnhandledException', [msg, stack]);
    }
  }
})

.run(function($ionicPlatform, $translate, $rootScope, PpItem, ItemDatabase, DsUtils, importService) {
//TEST MODE
   /*PpItem.destroyAll().then(function(){
        ItemDatabase.destroyAll().then(function(){
            var listItem = [
                {name:'Steak', date:new Date(2015,09,08,12,10), pp:8},
                {name:'Salad', date:new Date(2015,09,08,12,10), pp:3},
                {name:'Orange', date:new Date(2015,09,08,08,35), pp:2},
                {name:'Coffee', date:new Date(2015,09,08,08,35), pp:1},
            ];
            listItem.forEach(function(conso){
                var dbItem = DsUtils.createDatabaseItem(conso);
                DsUtils.createConso(conso, dbItem);
            });

        });
      });*/

  $ionicPlatform.ready(function() {
    if( /(android)/i.test(navigator.userAgent) ) { // for android
        importService.importAll();
        window.analytics.startTrackerWithId('UA-36178040-2');
    } else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
        window.analytics.startTrackerWithId('UA-36178040-6');
    }
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      //cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }
    $translate.use((navigator.language || navigator.userLanguage).split("-")[0]).then(function(data) {
      console.log("SUCCESS -> " + data);
    }, function(error) {
      console.log("ERROR -> " + error);
    });
  });

  $rootScope.trackView = function(name) {
    if (window.analytics) {
      window.analytics.trackView(name);
    }
  }

  $rootScope.trackEvent = function(cat, action, label, val) {
    if (window.analytics) {
      window.analytics.trackEvent(cat, action, label, val);
    }
  }
})

.controller('mainCtrl', function($ionicPlatform, $scope, $translate, $ionicModal, $ionicPopup, $ionicPopover, $cordovaAppRate, SettingsFactory, Weighing, PpUtils) {
  $scope.data = {
    slides : [
      {
        'name' : 'History',
        'template' : 'views/history.html',
        'viewable' : true
      },
      {
        'name' : 'Profile',
        'template' : 'views/profile.html',
        'viewable' : true
      },
      {
        'name' : 'FoodList',
        'template' : 'views/foodList.html',
        'viewable' : true
      },

      {
        'name' : 'Calculator',
        'template' : 'views/calculator.html',
        'viewable' : true
      }
    ]
  };

  $scope.slideChanged = function(index){
    $scope.trackView($scope.data.slides[index].name);
  }
  $ionicPlatform.ready(function() {
    $scope.trackView($scope.data.slides[0].name);
    $cordovaAppRate.promptForRating();
  });

  $ionicModal.fromTemplateUrl('views/modalConfigProfile.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalConfigProfile = modal;
  });

  $ionicPopover.fromTemplateUrl('views/headerPopOver.html', {
    scope: $scope
  }).then(function(popover) {
    $scope.headerPopover = popover;
  });

  $scope.showModalConfigProfile = function() {
    $scope.profilConfig = SettingsFactory.getProfile();
    $scope.modalConfigProfile.show();
  }

  $scope.saveConfigProgile = function(configProfile) {
    SettingsFactory.setProfile($scope.profilConfig);
    $scope.$broadcast(EVT_UPDATE_PROFILE);
  }

  $scope.showParamConfirm = function(actionString, callback) {
    var confirmPopup = $ionicPopup.confirm({
      title: actionString,
      template: $translate.instant("ARE_YOU_SURE_ACTION") + actionString
    });
    confirmPopup.then(function(res) {
      if(res) {
        callback();
      }
    });
  };

  $scope.wipeWeighing = function() {
    console.log("wipeWeighing");
    $scope.showParamConfirm($translate.instant('WIPE_WEIGHING'), function() {
      Weighing.destroyAll().then(function(){
        $scope.$broadcast(EVT_UPDATE_WEIGHT);
      });
    });
  }

  $ionicModal.fromTemplateUrl('views/modalAddExercice.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalAddExercice = modal;
  });

  $scope.popOverAddCons = function() {
    $scope.headerPopover.hide();
    $scope.$broadcast(EVT_OPEN_CONSUMPTION);
  }

  $scope.popOverAddWeighing = function() {
    $scope.headerPopover.hide();
    $scope.$broadcast(EVT_OPEN_WEIGHING);
  }

  $scope.popOverAddFoodList = function() {
    $scope.headerPopover.hide();
    $scope.$broadcast(EVT_OPEN_CONSUMPTION, {onlyFoodList : true});
  }

  $scope.popOverAddExercice = function() {
    $scope.headerPopover.hide();
    $scope.activity={level:'mod', duration:'30'};
    $scope.modalAddExercice.show();
  }

  $scope.saveActivity = function(activity) {
    $scope.modalAddExercice.hide();
    PpUtils.saveActivity(activity);
  }

})
