app.controller('foodList', function($scope, ItemDatabase, DsUtils, $ionicPopup, $translate){
  $scope.openPopup = function(item) {
    var buttons = [];
    if (item.pp>=0) {
      buttons.push(          {
                  text: '<b>'+$translate.instant('ADD_CONS')+'</b>',
                  type: 'button-positive',
                  onTap: function(e) {
                    var conso={name: item.name, date : new Date(), pp:item.pp };
                    DsUtils.createConso(conso, item);
                    return;
                  }
      });
    }
    buttons.push({
              text: '<b>'+$translate.instant('DELETE')+'</b>',
              type: 'button-positive',
              onTap: function(e) {
                $scope.trackEvent("PpConsumption", "remove", item.name, item.pp);
                ItemDatabase.destroy(item).then(function(){
                  console.log("items : " + JSON.stringify($scope.items));
                  firstLetter = item.name ? item.name.substring(0,1).toUpperCase() : "-";
                  var index = $scope.items[firstLetter].indexOf(item);
                  if (index > -1) {
                    $scope.items[firstLetter].splice(index, 1);
                    if ($scope.items[firstLetter].length == 0) {
                      delete $scope.items[firstLetter];
                    }
                  }
                });
                return;
              }
    });
    buttons.push({ text: $translate.instant('CANCEL') });
    var myPopup = $ionicPopup.show({
      title: $translate.instant('FOODLIST_POPUP_TITLE'),
      scope: $scope,
      cssClass: "popup-vertical-buttons",
      buttons: buttons
    });
  }

  $scope.refreshFoodList = function() {
    $scope.items= {};
    ItemDatabase.findAll({
      orderBy : [['name','ASC']]
    },{bypassCache:true}).then(function(result){
      result.sort(function(a, b){
        if (!a.name) return -1;
        if (!b.name) return 1;
        if(a.name.toLowerCase() < b.name.toLowerCase()) return -1;
        if(a.name.toLowerCase() > b.name.toLowerCase()) return 1;
        return 0;
      });

      var firstLetter;
      for(var i = 0; i < result.length; i++) {
	       firstLetter = result[i].name ? result[i].name.substring(0,1).toUpperCase() : "-";
	        if(!$scope.items[firstLetter]) {
            $scope.items[firstLetter] = [];
          }
	        $scope.items[firstLetter].push (result[i]);
      }
  });
}
$scope.refreshFoodList();

$scope.$on(EVT_UPDATE_FOODLIST,$scope.refreshFoodList);
});
