app.controller('history', function($rootScope, $scope, $filter,PpItem, PpUtils, $ionicPopup, $translate, $ionicScrollDelegate){
  $scope.itemPerPage = 6;
  $scope.items= {};
  $scope.totalLength = 0;
  $scope.noMoreItemsAvailable = false;

  $scope.loadMore = function() {
    PpUtils.loadConsumptionPromise($scope.totalLength, $scope.itemPerPage).then(function(result){
      $scope.totalLength += result.length;
      if (result.length!=$scope.itemPerPage) {
        $scope.noMoreItemsAvailable = true;
      }
      result.forEach(function(current){
        header = $filter('date')(current.date,'longDate');
         if(!$scope.items[header]) {
           $scope.items[header] = [];
         }
         $scope.items[header].push (current);
      });
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }

  $scope.openPopup = function(item) {
    var myPopup = $ionicPopup.show({
      title: $translate.instant('HISTO_POPUP_TITLE'),
      scope: $scope,
      cssClass: "popup-vertical-buttons",
      buttons: [
        {
          text: '<b>'+$translate.instant('DELETE')+'</b>',
          type: 'button-positive',
          onTap: function(e) {
            $scope.trackEvent("Database", "remove");
            PpItem.destroy(item).then(function(){
              for (cat in $scope.items){
                for (cur in $scope.items[cat]) {
                  if ($scope.items[cat][cur] === item) {
                    $scope.items[cat].splice(cur, 1);
                  }
                }
              }

              $rootScope.$broadcast(EVT_UPDATE_CONSUMPTION, "fromHistory");
            });
            return;
          }
        },
        { text: $translate.instant('CANCEL') },
      ]
    });
  }

  $scope.dividerFunction = function(key){
    return key;
  }

  $scope.refreshHisto = function(event, args) {
    if (args == "fromHistory") return;
    $scope.items= {};
    $scope.totalLength = 0;
    $scope.noMoreItemsAvailable = false;
    $ionicScrollDelegate.scrollTop(false);
  }
  $scope.$on(EVT_UPDATE_CONSUMPTION, $scope.refreshHisto);
});
