app.controller('profile', function($rootScope, $scope, $translate, PpUtils, Weighing, $ionicPopup){
  $scope.optionAlwaysShowTT = {
    onAnimationComplete: function(){this.showTooltip(this.segments, true);},
    tooltipEvents: [],
    tooltipFontSize: 10,
  };
  $scope.pointsLabels = [$translate.instant('CONSUMED'),$translate.instant('REMAINING')];

  $scope.optionWeight = {
    scaleType: "date",
    scaleDateFormat: "mmm d",
    scaleTimeFormat: "H:MM",
    scaleDateTimeFormat: "mmm d, yyyy, HH:MM",
  };

  $scope.populateProfile = function(){
    PpUtils.calcDailyConsumedPointsPromise().then(function(res){
      $scope.dailyAllowedPoints = PpUtils.calcDailyAllowedPoints();
      $scope.dailyConsumedPoints = Math.min(res.dailyConsumed,$scope.dailyAllowedPoints);
      $scope.bonusremaining = 49 - res.bonusConsumed;
      $scope.pointsData = [$scope.dailyConsumedPoints, $scope.dailyAllowedPoints-$scope.dailyConsumedPoints];
    });
  }
  $scope.populateProfile();

  $scope.addWeighing = function() {
    var myPopup = $ionicPopup.show({
      template: '<input type="number" ng-model="data.curWeighing" autofocus>',
      title: $translate.instant('DAY_WEIGHING'),
      scope: $scope,
      buttons: [
        { text: 'Cancel' },
        {
          text: '<b>' + $translate.instant('ADD') + '</b>',
          type: 'button-positive',
          onTap: function(e) {
            if (!$scope.data.curWeighing) { e.preventDefault(); }
            else { return $scope.data.curWeighing; }
          }
        }]
    }).then(function(curWeighing){
      if (curWeighing == undefined || curWeighing == 0) return;
      $scope.trackEvent("weighing", "add");
      var weighing = Weighing.createInstance({
        date:new Date(),
        dateString:new Date().toString(),
        weight:curWeighing
      });
      Weighing.inject(weighing);
      Weighing.create(weighing).then(function(res){
        $rootScope.$broadcast(EVT_UPDATE_WEIGHT);
      }, function(err){console.log("err:" + JSON.stringify(err))});;
    });
  }

  $scope.populateWeight = function() {
    Weighing.findAll({
      orderBy : [['date','ASC']]
    },{bypassCache:true}).then(function(result){
      console.log("populateWeight", result);
      $scope.weightData=[[]];
      if (result.length <2) return;
      result.forEach(function(current){
        var date = current.date;
        if (typeof date === 'string' || date instanceof String) {
          date = Date.parse(date);
        }
        $scope.weightData[0].push({x:date, y:current.weight});
      });
    });
  }
  $scope.populateWeight();

  $scope.$on(EVT_UPDATE_PROFILE,$scope.populateProfile);
  $scope.$on(EVT_UPDATE_CONSUMPTION,$scope.populateProfile);
  $scope.$on(EVT_UPDATE_WEIGHT,$scope.populateWeight);
  $scope.$on(EVT_OPEN_WEIGHING,$scope.addWeighing);
});
