app.factory('SettingsFactory', function() {

  var _settingsKey = "appSettings",
  defaultSettings = {
    profile: {
      sex:'female',
      height:165,
      weight:60,
      age:25,
      unit:'metric'
    }
  };

  function _retrieveSettings() {
    var settings = localStorage[_settingsKey];
    if(settings)
    return angular.fromJson(settings);
    return defaultSettings;
  }

  function _saveSettings(settings) {
    localStorage[_settingsKey] = angular.toJson(settings);
  }

  return {
    get: _retrieveSettings,
    set: _saveSettings,
    getProfile: function() {
      return _retrieveSettings().profile;
    },
    setProfile: function(profile) {
      var settings = _retrieveSettings();
      settings.profile = profile;
      _saveSettings(settings);
    }
  }
});
