app.service('DsUtils', function($rootScope, ItemDatabase, PpItem) {

  function _createConso(conso, databaseItem) {
    var ppItem = PpItem.createInstance({
      name:conso.name,
      date:conso.date,
      pp:conso.pp,
      databaseId : databaseItem?databaseItem.id:undefined
    });
    PpItem.inject(ppItem);
    PpItem.create(ppItem).then(function(res){
      $rootScope.$broadcast(EVT_UPDATE_CONSUMPTION);
    }, function(err){console.log("err:" + JSON.stringify(err),err)});

  }

  function _createConsoPromise(conso) {
    var ppItem = PpItem.createInstance({
      name:conso.name,
      date:conso.date,
      pp:conso.pp,
      databaseId :undefined
    });
    PpItem.inject(ppItem);
    return PpItem.create(ppItem);

  }

  function _createDatabaseItem(conso) {
    var itemDatabase = ItemDatabase.createInstance({
      name:conso.name,
      pp:conso.pp
    });
    ItemDatabase.inject(itemDatabase);
    ItemDatabase.create(itemDatabase).then(function(res){
      $rootScope.$broadcast(EVT_UPDATE_FOODLIST);
    }, function(err){console.log("err:" + JSON.stringify(err))});;
    return itemDatabase;
  }

  return {
    createConso : _createConso,
    createDatabaseItem : _createDatabaseItem,
    createConsoPromise : _createConsoPromise
  }
});
